-------------------------------------------------------------------------------
-- |
-- Module       : System.IOR
-- Copyright    : (c) Ivan Tomac 2008
-- License      : BSD3
--
-- Maintainer   : tomac `at` pacific `dot` net `dot` au
-- Stability    : experimental
--
-- Region based resource management for the IO monad.
-- Based on the ideas and code from
-- <http://okmij.org/ftp/Haskell/regions.html>
--
-------------------------------------------------------------------------------

module System.IOR (
    -- * Type Classes and Auxiliary Data Types
    RElem
  , RCons
  , RNil

    -- * IOR Monad
  , IOR

  , runIOR
  , newIOR

    -- * Region Tags
  , IORTag

  , getIORTag
  , withIORTag
) where

import System.IOR.Internal
